#!/usr/bin/python
# -*- coding: utf-8 -*-

def compare( v1, v2 ):
    msg = 'сравнения объекта <{0}({1})> и объекта <{2}({3})>'.format( v1.__class__, str( v1 ), v2.__class__, str( v2 ) )
    try:
        print( "{:80}\t: '=='->{}\t|   !='->{}" \
               .format( msg, v1==v2, v1!=v2 ) )
    except TypeError:
        print( '{:80}\t: не сравнимые типы объектов!'.format( msg ) )


class obj0:
    def __init__( self, id ):
        self.id = id
    def __str__( self ):
        return str( self.id )

class obj1( obj0 ):
    def __init__( self, id ):
        obj0.__init__( self, id )  
    def __eq__( self, other ):
        if isinstance( other, obj1 ): 
            return self.id == other.id 
        else:
            raise TypeError

class obj2( obj0 ):
    def __init__( self, id ):
        obj0.__init__( self, id )  
    def __eq__( self, other ):
        if isinstance( other, obj2 ): 
            return self.id == other.id 
        else:
            raise TypeError
    def __ne__( self, other ):
        return not self == other 


compare( obj0( 13 ), obj0( 13 ) )
compare( obj0( 13 ), obj0( 31 ) )
compare( obj1( 24 ), obj1( 24 ) )
compare( obj1( 24 ), obj1( 42 ) )
compare( obj2( 35 ), obj2( 35 ) )
compare( obj2( 35 ), obj2( 53 ) )

compare( obj0( 77 ), obj1( 77 ) )
compare( obj1( 88 ), obj0( 88 ) )
compare( 55, obj1( 55 ) )
compare( obj1( 55 ), 55 )

